/*
 * Copyright 1991-1997, Brown University, Providence, RI.
 * 
 *                         All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose other than its incorporation into a
 * commercial product is hereby granted without fee, provided that the
 * above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Brown University not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * BROWN UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY
 * PARTICULAR PURPOSE.  IN NO EVENT SHALL BROWN UNIVERSITY BE LIABLE FOR
 * ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
char *fallbacks[] = {
   "XMtg.Form.select.fromHoriz:		file",
   "XMtg.Form.pref.fromHoriz:		select",
   "XMtg.Form.teleptr.fromHoriz:	pref",

   "XMtg.Form.add.fromVert:		file",
   "XMtg.Form.add.vertDistance:		12",

   "XMtg.Form.drop.fromVert:		add",

   "XMtg.Form.floor.fromVert:		drop",
   "XMtg.Form.floor.vertDistance:	12",
   "XMtg.Form.seat.fromVert:		floor",
   "XMtg.Form.view.fromVert:		seat",

   "XMtg.Form.grab.fromVert:		view",
   "XMtg.Form.grab.vertDistance:	12",

   "XMtg.Form.viewport.fromVert:	file",
   "XMtg.Form.viewport.fromHoriz:	add",
   "XMtg.Form.viewport.right:		ChainRight",
   "XMtg.Form.viewport.bottom:		ChainBottom",

   "XMtg*left:				ChainLeft",
   "XMtg*right:				ChainLeft",
   "XMtg*top:				ChainTop",
   "XMtg*bottom:			ChainTop",

   "XMtg*TransientShell.allowShellResize:	True",
   "XMtg*shapeStyle:			oval",
   "XMtg*cursor:			left_ptr",
   "XMtg*MenuButton.leftBitmap:		menu12",
   "XMtg*baseTranslations:#override\\n\
			Ctrl<Key>o:		do-open()\\n\
			Ctrl<Key>s:		do-save()\\n\
			Ctrl<Key>a:		do-all()\\n\
			Shift<Key>a:		do-add()\\n\
			Shift<Key>d:		do-drop()\\n\
			Shift<Key>f:		do-floor()\\n\
			Shift<Key>s:		do-seat()\\n\
			Shift<Key>v:		do-view()\\n\
			Shift<Key>g:		do-grab()\\n\
			Ctrl<Key>c:		do-quit()\\n\
			<Key>q:			do-quit()",
   "XMtg*open.Dialog*Translations:#override\\n\
			<Key>Return:		do-accept(open)\\n\
			Ctrl<Key>c:		do-cancel(open)",
   "XMtg*save.Dialog*Translations:#override\\n\
			<Key>Return:		do-accept(save)\\n\
			Ctrl<Key>c:		do-cancel(save)",
   "XMtg*add_form*Translations:#override\\n\
			<Key>Return:		do-accept(add)\\n\
			Ctrl<Key>c:		do-cancel(add)",
   "XMtg*drop_form*Translations:#override\\n\
			<Key>Return:		do-accept(drop)\\n\
			Ctrl<Key>c:		do-cancel(drop)",

   "XMtg*add_form.input.width:		250",

   "XMtg*add_form.floor.label:		Floor",
   "XMtg*add_form.seat.label:		Seat",
   "XMtg*add_form.view.label:		View",
   "XMtg*add_form.floor.state:		True",
   "XMtg*add_form.Toggle.Translations:#override\\n\
			<EnterWindow>:		highlight(Always)\\n\
			<LeaveWindow>:		unhighlight()\\n\
			<Btn1Down>,<Btn1Up>:	set() notify()",
   "XMtg*add_form.input.fromVert:	add_label",
   "XMtg*add_form.mode_label.fromVert:	input",
   "XMtg*add_form.floor.fromVert:	input",
   "XMtg*add_form.floor.fromHoriz:	mode_label",
   "XMtg*add_form.seat.fromVert:	input",
   "XMtg*add_form.seat.fromHoriz:	floor",
   "XMtg*add_form.view.fromVert:	input",
   "XMtg*add_form.view.fromHoriz:	seat",
   "XMtg*add_form.accept.fromVert:	mode_label",
   "XMtg*add_form.cancel.fromVert:	mode_label",
   "XMtg*add_form.cancel.fromHoriz:	accept",

   "XMtg*add_form.input.resizable:	True",
   "XMtg*add_form.input.left:		ChainLeft",
   "XMtg*add_form.input.right:		ChainRight",

   "XMtg*drop_form.accept.fromVert:	drop_label",
   "XMtg*drop_form.cancel.fromVert:	drop_label",
   "XMtg*drop_form.cancel.fromHoriz:	accept",

   "XMtg*drop_form.input.resizable:	True",
   "XMtg*drop_form.input.left:		ChainLeft",
   "XMtg*drop_form.input.right:		ChainRight",

   "XMtg*error_form.dismiss.fromVert:	messages",

   "XMtg*error.allowShellResize:	True",
   "XMtg*error_form.messages.editType:	read",
   "XMtg*error_form.messages.displayCaret:	False",
   "XMtg*error_form.messages.resize:	both",
   "XMtg*error_form.messages.resizable:	True",
   "XMtg*error_form.messages.left:	ChainLeft",
   "XMtg*error_form.messages.right:	ChainRight",

   "XMtg*accept.label:		Accept",
   "XMtg*cancel.label:		Cancel",
   "XMtg*dismiss.label:		Dismiss",

   "XMtg*TransientShell.width:		250",
   "XMtg*Dialog.label.justify:		left",
/*
   "XMtg*MenuButton.width:		58",
*/
   "XMtg*SimpleMenu.width:		0",
   "XMtg*SimpleMenu.height:		0",
   "XMtg*SimpleMenu.cursor:		hand2",
   "XMtg*SimpleMenu.line.height:	0",

   "XMtg.Form.file.label:		File",
   "XMtg.Form.file.menuName:		file_menu",

   "XMtg*file_menu.open.label:		Open (Ctrl-o)...",
   "XMtg*file_menu.save.label:		Save (Ctrl-s)...",
   "XMtg*file_menu.quit.label:		Quit (Ctrl-c, q)",

   "XMtg.Form.pref.label:		Prefs",
   "XMtg.Form.pref.menuName:		pref_menu",
   "XMtg*pref_menu.tba.label:		<undefined>",

   "XMtg.Form.select.label:		Select",
   "XMtg.Form.select.menuName:		select_menu",
   "XMtg*select_menu.all.label:		All (Ctrl-a)",

   "XMtg.Form.teleptr.label:		Telepointer",
   "XMtg.Form.add.label:		Add...",
   "XMtg.Form.drop.label:		Drop",
   "XMtg.Form.floor.label:		Floor",
   "XMtg.Form.seat.label:		Seat",
   "XMtg.Form.view.label:		View",
   "XMtg.Form.grab.label:		Grab",

   "XMtg*grid.width:			250",
   "XMtg*grid.height:			200",

   "XMtg*SmeBSB.HorizontalMargins:	32",
   (char *)0
};
