.\" Copyright 1996, Brown University.
.\" 
.TH XMTG 1 "28 Mar 1996"
.SH NAME
xmtg - X multiplexor control client
.SH SYNOPSIS
.B xmtg
[-option ...] [\fIlayout\fP]
.SH DESCRIPTION
.I Xmtg
is an X program that provides dynamic control of a shared X session.
It allows X servers to be added to or removed from the session and
provides control over which X servers can provide input to shared X
clients.
.LP
.I Xmtg
provides a graphical depiction of a shared X session in which each
X server is represented by an icon that reflects its state.
.SH "OPTIONS"
.PP
.I Xmtg
accepts the following options:
.TP 8
.B \-chair \fItag\fP
This option forces the X server identified by
.I tag
to always have the floor throughout the meeting.  Attempts to assign
other input modes are refused.
.TP 8
.B \-help
This option (or any unsupported option) will cause a brief description of 
the allowable options and parameters to be printed.
.TP 8
.B \-layoutpath \fIpath\fP
This option specifies the path to search for layout files.  The path is
a colon-separated list of directories.
.TP 8
.B \-mdisplay \fIdisplay\fP
This option specifies the X multiplexor to be used; see \fIxmx(1)\fP.
If this option is not specified, the X server is assumed to also be
an X multiplexor.
.SH "SEE ALSO"
X(1), xmx(1)
.SH ENVIRONMENT
.TP 8
.B DISPLAY
X server display to use.
.TP 8
.B MDISPLAY
X multiplexor to use if different from the X server.
.TP 8
.B XMTGCHAIR
Tag name of X server which must always have the floor.
.TP 8
.B XMTGLAYOUTPATH
Path to search for layout file.
.SH BUGS
.PP
Numerous.
.SH AUTHOR
John Bazik
