/*
 * Copyright 1991-1998, Brown University, Providence, RI.
 * 
 *                         All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose other than its incorporation into a
 * commercial product is hereby granted without fee, provided that the
 * above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Brown University not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * BROWN UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY
 * PARTICULAR PURPOSE.  IN NO EVENT SHALL BROWN UNIVERSITY BE LIABLE FOR
 * ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#include <xmc.h>
#include <xmclib.h>
#include <xmcp.h>
#include "common.h"

TptrId
XmcCreatePixmapTptr
   AL((muxp, disp_mask, source, mask, x, y, fgcolor, bgcolor))
   DB Mux *muxp
   DD unsigned int disp_mask
   DD XId source
   DD XId mask
   DD int x
   DD int y
   DD XmcColor *fgcolor
   DD XmcColor *bgcolor
   DE
{
   xmcCreateTptrReq *p;

   p = (xmcCreateTptrReq *)Xmc_allocout(muxp, sz_xmcCreateTptrReq);

   p->code = XMC_CreateTptr;
   p->mask = disp_mask;
   p->length = sz_xmcCreateTptrReq;
   p->srcID = source;
   p->mskID = mask;
   p->hotx = x;
   p->hoty = y;
   if (fgcolor) {
      p->foreRed = fgcolor->red;
      p->foreGreen = fgcolor->green;
      p->foreBlue = fgcolor->blue;
   }
   if (bgcolor) {
      p->backRed = bgcolor->red;
      p->backGreen = bgcolor->green;
      p->backBlue = bgcolor->blue;
   }
   muxp->outseqno++;
}
