/*
 * Copyright 1991-1998, Brown University, Providence, RI.
 * 
 *                         All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose other than its incorporation into a
 * commercial product is hereby granted without fee, provided that the
 * above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Brown University not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * BROWN UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY
 * PARTICULAR PURPOSE.  IN NO EVENT SHALL BROWN UNIVERSITY BE LIABLE FOR
 * ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#include <xmc.h>
#include <xmclib.h>
#include <xmcp.h>
#include "common.h"

int
XmcGetEventMask
   AL((muxp, mp))
   DB Mux *muxp
   DD Emask *mp
   DE
{
   xmcGetEventMaskReq *p;
   xmcGetEventMaskReply *r;

   p = (xmcGetEventMaskReq *)Xmc_allocout(muxp, sz_xmcGetEventMaskReq);

   p->code = XMC_GetEventMask;
   p->length = sz_xmcGetEventMaskReq;

   muxp->outseqno++;

   Xmc_flush(muxp);

   if ((r = (xmcGetEventMaskReply *)Xmc_reply(muxp)) == 0)
      return -1;

   *mp = r->mask;

   Xmc_inclear(muxp, r->length);
   return 0;
}
