/*
 * Copyright 1991-1998, Brown University, Providence, RI.
 * 
 *                         All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose other than its incorporation into a
 * commercial product is hereby granted without fee, provided that the
 * above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Brown University not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.
 * 
 * BROWN UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR ANY
 * PARTICULAR PURPOSE.  IN NO EVENT SHALL BROWN UNIVERSITY BE LIABLE FOR
 * ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#include <xmc.h>
#include <xmclib.h>
#include <xmcp.h>
#include "common.h"

void
XmcSetAuth
   AL((muxp, cookie, perms))
   DB Mux *muxp
   DD XmcCookie *cookie
   DD PMask perms
   DE
{
   register int totlen;
   register char *cp;
   xmcSetAuthReq *p;

   totlen = sz_xmcSetAuthReq + cookie->namelen + cookie->datalen;
   totlen += PAD(totlen);

   p = (xmcSetAuthReq *)Xmc_allocout(muxp, totlen);

   p->code = XMC_SetAuth;
   p->length = totlen;
   p->pMask = perms;
   p->nBytesName = cookie->namelen;
   p->nBytesData = cookie->datalen;

   cp = (char *)(p + 1);
   bcopy(cookie->name, cp, cookie->namelen);
   cp += cookie->namelen;
   bcopy(cookie->data, cp, cookie->datalen);

   muxp->outseqno++;
}
