#include "color.pub.h"
#include "cursor.pub.h"
#include "error.pub.h"
#include "event.pub.h"
#include "expos.pub.h"
#include "focus.pub.h"
#include "gc.pub.h"
#include "hash.pub.h"
#include "imask.pub.h"
#include "inp.pub.h"
#include "list.pub.h"
#include "pixmap.pub.h"
#include "plist.pub.h"
#include "prop.pub.h"
#include "proto.pub.h"
#include "sres.pub.h"
#include "util.pub.h"
#include "window.pub.h"
#include "zb.pub.h"
static FUNC( int, client_window_unmap, (window_t *, client_t *));
static FUNC( void, client_window_death, (window_t *, client_t *));
static FUNC( void, purge_xmc_client, (window_t *, xmc_t *));
static FUNC( int, process_attrs, (client_t *, u16_t, window_t *, mask_t, 
	u32_t *, u32_t *));
static FUNC( void, ketchup, (window_t *));
static FUNC( void, expose, (window_t *));
static FUNC( void, touch_emasks, (window_t *));
static FUNC( void, map_window, (window_t *));
static FUNC( int, unmap_subwindows, (window_t *, u8_t));
static FUNC( int, unmap_tree, (window_t *, u8_t));
static FUNC( int, unmap_window, (window_t *, u8_t));
static FUNC( void, link_window, (window_t *, window_t *));
static FUNC( void, update_level, (window_t *, u16_t));
static FUNC( void, unlink_window, (window_t *));
static FUNC( void, free_subwindows, (window_t *));
static FUNC( void, free_tree, (window_t *));
static FUNC( void, free_window, (window_t *));
static FUNC( void, reset_tree, (window_t *));
static FUNC( void, free_savesets, (window_t *));
static FUNC( void, reparent_window_xy, (window_t *, window_t *));
static FUNC( void, reparent_window, (window_t *, window_t *));
static FUNC( void, reparent_savesets, (window_t *, client_t *));
static FUNC( void, sib_to_top, (window_t *));
static FUNC( void, sib_to_bottom, (window_t *));
static FUNC( void, sib_above, (window_t *, window_t *));
static FUNC( void, sib_below, (window_t *, window_t *));
static FUNC( void, gravity_reconfig, (window_t *, int, int, int, int, 
	uint_t *));
